<template>
  <a-card :bordered="false">
    <div class="table-page-search-wrapper">
      <a-form layout="inline">
        <a-row :gutter="48">
          <a-col :md="8" :sm="24">
            <a-form-item label="关键字">
              <a-input v-model="queryParam.keyword" placeholder="请输入名称/类型名称"/>
            </a-form-item>
          </a-col>
          <a-col :md="8" :sm="24">
            <a-form-item
              label="类别"
            >
              <a-select v-model="queryParam.type">
                <a-select-option
                  v-for="(value,key) in typeMap"
                  :key="key"
                  :label="key"
                  :value="key">{{ value }}</a-select-option>
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :md="8 || 24" :sm="24">
            <span class="table-page-search-submitButtons">
              <a-button type="primary" @click="$refs.table.refresh(true)">查询</a-button>
              <a-button style="margin-left: 8px" @click="resetSearchForm">重置</a-button>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>

    <div class="table-operator">
      <a-button v-if="$auth('operate-articles-add')" type="primary" icon="plus" @click="$refs.baseModal.base()">新增</a-button>
      <a-dropdown v-action:edit v-if="selectedRowKeys.length > 0 && $auth('operate-articles-del')">
        <a-menu slot="overlay">
          <a-popconfirm title="是否要删除所选数据？" @confirm="batchDelete()">
            <a-menu-item key="1"><a-icon type="delete" /><a>删除</a></a-menu-item>
          </a-popconfirm>
        </a-menu>
        <a-button style="margin-left: 8px">
          批量操作 <a-icon type="down" />
        </a-button>
      </a-dropdown>
    </div>

    <s-table
      ref="table"
      size="default"
      rowKey="id"
      :columns="columns"
      :data="loadData"
      :alert="options.alert"
      :rowSelection="options.rowSelection"
      showPagination="auto"
    >
      <span slot="type" slot-scope="text"> <!--slot-scope="text"-->
        {{ typeMap[text] }}
      </span>

      <span slot="download" slot-scope="record">
        <a-button style="margin-left: 8px" icon="download" @click="downTemplate(record.picture)">下载文件</a-button>
      </span>
      <span slot="action" slot-scope="record">
        <template>
          <a @click="handleView(record)">查看</a>
          <a-divider type="vertical" />
          <a @click="handleEdit(record)">修改</a>
          <a-divider type="vertical" />
          <a-popconfirm v-if="record.status == 1" title="是否要废弃该条数据？" @confirm="batchDelete(record.id)">
            <a>废弃</a>
          </a-popconfirm>
           <a-popconfirm v-if="record.status == null || record.status == 0" title="是否要启用该条数据？" @confirm="batchQi(record.id)">
            <a>启用</a>
          </a-popconfirm>
        </template>
      </span>
    </s-table>
    <base-form ref="baseModal" :typeMap="typeMap" @ok="handleOk"/>
    <detail ref="detailModal" :typeMap="typeMap"/>
  </a-card>
</template>

<script>
import { STable, Ellipsis } from '@/components'
import BaseForm from './modules/BaseForm'
import Detail from './modules/Detail'
import { getArticlePage, deleteArticles, fetchArticle, qiArticles } from '@/api/operate/article'
import DictCache from '@/utils/dict'

export default {
  name: 'ArticleList',
  components: {
    STable,
    Ellipsis,
    BaseForm,
    Detail
  },
  data () {
    return {
      // 查询参数
      queryParam: {
      },
      typeMap: {},
      // 表头

      columns: [
        {
          title: '序号',
          dataIndex: 'index',
          customRender: (text, record, index) => {
            return `${(this.$refs.table.localPagination.current - 1) * this.$refs.table.localPagination.pageSize + index + 1}`
          }
        },
        {
          title: '类别',
          dataIndex: 'type',
          scopedSlots: { customRender: 'type' }
        },
        {
          title: '标题',
          dataIndex: 'title'
        },
        {
          title: '文件',
          scopedSlots: { customRender: 'download' }
        },
        {
          title: '是否置顶',
          dataIndex: 'topFlag',
          customRender: (text) => (text ? '是' : '否')
        },
        {
          title: '状态',
          dataIndex: 'status',
          customRender: (text) => (text ? '启用' : '废弃')
        },
        {
          title: '排序',
          dataIndex: 'sort'
        },
       /* {
          title: '发布时间',
          dataIndex: 'createdTime'
        },*/
        {
          title: '操作',
          key: 'action',
          align: 'center',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        parameter = {
          ...parameter,
          keyword: this.queryParam.keyword,
          dataScope: {
            sortBy: 'desc',
            sortName: 'update_time'
          }
        }
        return getArticlePage(Object.assign(parameter, this.queryParam))
          .then(res => {
            return res.data
          })
      },
      selectedRowKeys: [],
      selectedRows: [],

      options: {
        alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
        rowSelection: {
          selectedRowKeys: this.selectedRowKeys,
          onChange: this.onSelectChange
        }
      },
      optionAlertShow: false
    }
  },
  created () {
    this.getDict()
  },
  methods: {
    tableOption () {
      if (!this.optionAlertShow) {
        this.options = {
          alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
          rowSelection: {
            selectedRowKeys: this.selectedRowKeys,
            onChange: this.onSelectChange,
            getCheckboxProps: record => ({
              props: {
                disabled: false,
                name: record.id
              }
            })
          }
        }
        this.optionAlertShow = true
      } else {
        this.options = {
          alert: false,
          rowSelection: null
        }
        this.optionAlertShow = false
      }
    },
    batchDelete (id) {
      let ids = []
      if (this.BaseTool.String.isBlank(id)) {
        const length = this.selectedRows.length
        if (length === 0) {
          this.$message.info('请选择要废弃的记录')
          return
        }
        ids = this.selectedRows.map(item => item.id)
      } else {
        ids = [id]
      }
      deleteArticles(ids).then(res => {
        this.$message.info('废弃成功')
        this.handleOk()
        this.$refs.table.clearSelected()
      })
    },
    batchQi (id) {
      let ids = []
      if (this.BaseTool.String.isBlank(id)) {
        const length = this.selectedRows.length
        if (length === 0) {
          this.$message.info('请选择要启用的记录')
          return
        }
        ids = this.selectedRows.map(item => item.id)
      } else {
        ids = [id]
      }
      qiArticles(ids).then(res => {
        this.$message.info('启用成功')
        this.handleOk()
        this.$refs.table.clearSelected()
      })
    },
    handleEdit (record) {
      fetchArticle({ id: record.id }).then(res => {
        const modal = this.$refs.baseModal
        modal.base(res.data)
      })
    },
    handleView (record) {
      fetchArticle({ id: record.id }).then(res => {
        const modal = this.$refs.detailModal
        modal.base(res.data)
      })
    },
    handleOk () {
      this.$refs.table.refresh()
    },
    onSelectChange (selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    resetSearchForm () {
      this.queryParam = {
      }
      this.$refs.table.refresh(true)
    },
    getDict () {
      this.typeMap = DictCache.getLabelByValueMapByType('ARTICLE_TYPE')
      this.tableOption()
    },
    downTemplate (picture) {
      const a = document.createElement('a')
      console.log('picture: ' + picture)
      a.href = picture
      a.target = '_blank'
      a.click()
    }
  }
}
</script>
